package com.fr.plugin.demo;

import com.fanruan.api.design.DesignKit;
import com.fanruan.api.design.chart.field.BaseCellDataFieldsPane;
import com.fanruan.api.design.ui.component.formula.UIFormulaTextField;

import java.awt.Component;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-05
 */
public class DemoCellDataFieldsPane extends BaseCellDataFieldsPane<DemoColumnFieldCollection> {

    private UIFormulaTextField categoryPane;
    private UIFormulaTextField valuePane;

    public void initComponents(){
        categoryPane = new UIFormulaTextField();
        valuePane = new UIFormulaTextField();
        super.initComponents();
    }

    @Override
    protected String[] fieldLabels() {
        return new String[]{
                DesignKit.i18nText("Fine-Plugin_Demo_Category"),
                DesignKit.i18nText("Fine-Plugin_Demo_Value")
        };
    }

    @Override
    protected Component[] fieldComponents() {
        return new Component[]{
                categoryPane,
                valuePane
        };
    }

    @Override
    protected UIFormulaTextField[] formulaPanes() {
        return new UIFormulaTextField[]{
                categoryPane,
                valuePane
        };
    }

    @Override
    public void populateBean(DemoColumnFieldCollection dataConf) {
        populateField(categoryPane, dataConf.getCategory());
        populateField(valuePane, dataConf.getValue());
    }

    @Override
    public DemoColumnFieldCollection updateBean() {
        DemoColumnFieldCollection dataConfig = new DemoColumnFieldCollection();

        updateField(categoryPane, dataConfig.getCategory());
        updateField(valuePane, dataConfig.getValue());

        return dataConfig;
    }
}
