package com.fr.plugin.demo;

import com.fanruan.api.design.DesignKit;
import com.fanruan.api.design.chart.field.BaseDataSetFieldsPane;
import com.fanruan.api.design.ui.component.UIComboBox;
import com.fanruan.api.design.ui.component.chart.CalculateComboBox;

import java.awt.Component;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-05
 */
public class DemoDataSetFieldsPane extends BaseDataSetFieldsPane<DemoColumnFieldCollection> {

    private UIComboBox categoryPane;
    private UIComboBox valuePane;
    private CalculateComboBox calculateComboBox;

    public void initComponents() {
        categoryPane = new UIComboBox();
        valuePane = new UIComboBox();
        calculateComboBox = new CalculateComboBox();
        super.initComponents();
    }

    @Override
    protected String[] fieldLabels() {
        return new String[]{
                DesignKit.i18nText("Fine-Plugin_Demo_Category"),
                DesignKit.i18nText("Fine-Plugin_Demo_Value"),
                DesignKit.i18nText("Fine-Plugin_Demo_Summary_Method")
        };
    }

    @Override
    protected Component[] fieldComponents() {
        return new Component[]{
                categoryPane,
                valuePane,
                calculateComboBox
        };
    }

    @Override
    protected UIComboBox[] filedComboBoxes() {
        return new UIComboBox[]{
                categoryPane,
                valuePane
        };
    }

    @Override
    public void populateBean(DemoColumnFieldCollection dataConf) {
        populateField(categoryPane, dataConf.getCategory());
        populateFunctionField(valuePane, calculateComboBox, dataConf.getValue());
    }

    @Override
    public DemoColumnFieldCollection updateBean() {
        DemoColumnFieldCollection dataConfig = new DemoColumnFieldCollection();

        updateField(categoryPane, dataConfig.getCategory());
        updateFunctionField(valuePane, calculateComboBox, dataConfig.getValue());

        return dataConfig;
    }
}
