package com.fr.plugin.demo;

import com.fanruan.api.report.chart.BaseChartType;
import com.fanruan.api.report.chart.BaseChartWithData;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-06
 */
public class DemoType extends BaseChartType {

    /**
     * 该种图表所有的图表对象实例，比如柱形图就有堆积柱形图，百分比堆积柱形图等等
     *
     * @return 所有的图表对象实例
     */
    public BaseChartWithData[] getChartTypes() {
        return new BaseChartWithData[]{
                createDemoChart(PieType.PIE),
                createDemoChart(PieType.RING)
        };
    }

    /**
     * 图表在web端展现时需要的JS文件
     *
     * @return JS文件数组
     */
    public String[] getRequiredJS() {
        return new String[]{
                "com/fr/plugin/demo/demoWrapper.js",
                "com/fr/plugin/demo/echarts.js"
        };
    }

    /**
     * 图表在web端展现时需要的CSS文件
     *
     * @return CSS文件数组
     */
    public String[] getRequiredCss() {
        return new String[]{
                "com/fr/plugin/demo/demo.css"
        };
    }

    /**
     * JS对象名，该对象一般是一个函数，执行后会在给定的dom中绘制图表
     *
     * @return JS对象名
     */
    public String getWrapperName() {
        return "demoWrapper";
    }

    private DemoChart createDemoChart(PieType pieType) {
        DemoChart demoChart = new DemoChart();
        demoChart.setPieType(pieType);
        return demoChart;
    }
}
