package com.fr.plugin.demo;

import com.fanruan.api.design.DesignKit;
import com.fanruan.api.design.chart.BaseChartTypeUI;
import com.fanruan.api.design.chart.BaseDataPane;
import com.fanruan.api.design.chart.BaseOtherPane;
import com.fanruan.api.design.chart.DefaultOtherPane;
import com.fanruan.api.design.chart.DefaultTypePane;
import com.fanruan.api.design.chart.SingleDataPane;
import com.fr.design.gui.frpane.AttributeChangeListener;

/**
 * @author Bjorn
 * @version 10.0
 * Created by Bjorn on 2019-09-05
 */
public class DemoUI extends BaseChartTypeUI {

    @Override
    public DefaultTypePane getPlotTypePane() {
        return new DemoTypePane();
    }

    @Override
    public BaseDataPane getChartDataPane(AttributeChangeListener listener) {
        return new BaseDataPane(listener) {
            @Override
            protected SingleDataPane createSingleDataPane() {
                return new SingleDataPane(new DemoDataSetFieldsPane(), new DemoCellDataFieldsPane());
            }
        };
    }

    @Override
    public BaseOtherPane[] getAttrPaneArray(AttributeChangeListener listener) {
        return new BaseOtherPane[]{new DemoTitlePane(), new DefaultOtherPane()};
    }

    @Override
    public String getIconPath() {
        return "com/fr/plugin/demo/icon.png";
    }

    @Override
    public String getName() {
        return DesignKit.i18nText("Fine-Plugin_Demo_Chart");
    }

    @Override
    public String[] getSubName() {
        return new String[]{
                DesignKit.i18nText("Fine-Plugin_Pie"),
                DesignKit.i18nText("Fine-Plugin_Ring")
        };
    }

    @Override
    public String[] getDemoImagePath() {
        return new String[]{
                "com/fr/plugin/demo/pie.png",
                "com/fr/plugin/demo/ring.png"
        };
    }
}
